<template>
    <BFormGroup v-bind:id="inputName" v-bind:label="inputLabel" v-bind:label-for="inputName">
        <BFormInput
            v-bind:id="inputName"
            v-model="mutedValue"
            @keyup="$emit('update', mutedValue)"
            v-validate="{ required: true }"
            v-bind:name="inputName"
            v-bind:type="inputType"
            :state="validateState(inputName)"
            v-bind:data-vv-as="inputLabel"
        />
        <div v-show="veeErrors.first(inputName)" class="invalid-feedback">
            {{ veeErrors.first(inputName) }}
        </div>
    </BFormGroup>
</template>

<script>
export default {
    name: 'BaseValidationInput',
    props: {
        inputName: String,
        inputLabel: String,
        inputValue: String,
        inputType: String,
    },
    data() {
        return {
            mutedValue: '',
        };
    },
    watch: {
        inputValue() {
            this.mutedValue = this.$props.inputValue;
        },
    },
    methods: {
        validateState(ref) {
            if (this.veeFields[ref] && (this.veeFields[ref].dirty || this.veeFields[ref].validated)) {
                return !this.veeErrors.has(ref);
            }
            return null;
        },
    },

    inject: ['$validator'],
};
</script>
<style lang="scss" scoped>
input {
    min-width: 410px;
    width: 100%;
}
@media (max-width: 450px) {
    input {
        width: calc(100vw - 37px);
    }
}
</style>
